 /*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* This code is derived from X-VFlib's vffuncs.c */

/* pool.c */

/* $Id: pool.c,v 1.4 1998/05/31 15:13:24 elca Exp $ */

/*******************************************************************
 * CharInfo Pool
 */

#include "Type1_16.h"
#include "Type1_16struct.h"

/*#define dprintf(str) fprintf str */
#define dprintf(str) /* */

#define CharInfoPoolUnitSize 256

CharInfoPoolPtr CharInfoPool_Alloc(int bitmapSize)
{
	CharInfoPoolPtr this = (CharInfoPoolPtr) malloc(sizeof(CharInfoPool));

	dprintf((stdout, "\n+" __FUNCTION__ "()\n" ));

	if (this != NULL) {
		memset(this, 0x00, sizeof(CharInfoPool));
		this->bitmapSize = bitmapSize;
	}

	dprintf((stdout, "-" __FUNCTION__ "()\n\n" ));

	return this;
}

CharInfoPtr CharInfoPool_Get(CharInfoPoolPtr this)
{
	int i;
	CharInfoUnitPtr ptr;
	CharInfoPtr cptr;
	char *bptr;

	dprintf((stdout, "\n+" __FUNCTION__ "()\n" ));

	if ((this->n == 0) || (this->index == CharInfoPoolUnitSize)) {
		ptr = (CharInfoUnitPtr) xrealloc(this->unit,
						 (this->n + 1) *
						 sizeof(CharInfoUnit));
	if (ptr == NULL) {
	    return NULL;
	}
	this->unit = ptr;
	cptr = (CharInfoPtr) xalloc(CharInfoPoolUnitSize * sizeof(CharInfoRec));
	if (cptr == NULL) {
	    return NULL;
	}
	bptr = (char *) xalloc(CharInfoPoolUnitSize * this->bitmapSize);
	if (bptr == NULL) {
	    xfree(cptr);
	    return NULL;
	}
	this->unit[this->n].charInfo = cptr;
	this->unit[this->n].bitmap = bptr;
	memset(bptr, 0x00, this->bitmapSize * CharInfoPoolUnitSize);
	for (i = 0; i < CharInfoPoolUnitSize; i++) {
	    cptr->bits = bptr;
	    cptr++;
	    bptr += this->bitmapSize;
	}
	this->n++;
	this->index = 0;
    }

	dprintf((stdout, "-" __FUNCTION__ "()\n\n" ));


    return &this->unit[this->n - 1].charInfo[this->index++];
}

void CharInfoPool_Free(CharInfoPoolPtr this)
{
	int i;

	dprintf((stdout, "\n+" __FUNCTION__ "()\n" ));

	for (i = 0; i < this->n; i++) {
		xfree(this->unit[i].charInfo);
		xfree(this->unit[i].bitmap);
	}
	xfree(this->unit);
	this->n = 0;

	dprintf((stdout, "-" __FUNCTION__ "()\n\n" ));

}

/* end */
